#if !defined  HAVE_NORMALBASIS_H__
#define       HAVE_NORMALBASIS_H__

#include "bpol/poly-tab.h"  // precomputed normal polynomials
#include "bpol/normal-solvequadratic.h"  // solve x^2+x==c

#include "fxttypes.h"

// bpol/bitpol-normal.cc:
bool bitpol_normal2_q(ulong c, ulong n);
bool bitpol_normal_q(ulong c, ulong n, ulong iq=0, ulong *M=0);

// bpol/normal-mult.cc:
ulong normal_mult(ulong a, ulong b, const ulong *M, ulong n);


#endif  // !defined HAVE_NORMALBASIS_H__
